--[[
Yikes
	Author: Billi@Aszune
	Version:	0.1
	Change Log:
		2008-04-14 0.1 Initial Release
]]

Yikes = LibStub("AceAddon-3.0"):NewAddon("Yikes", "AceConsole-3.0", "AceEvent-3.0")
local media = LibStub("LibSharedMedia-2.0")
--local L = LibStub("AceLocale-3.0"):GetLocale("Yikes", true)

local screenVisible = true;
local afkFrame = CreateFrame("ScrollingMessageFrame", "Yikes", UIParent)
local texture = afkFrame:CreateTexture()
local volume = GetCVar("Sound_MasterVolume")

function Yikes:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("Yikes_DB", self:GetDefaultConfig())
	Yikes:SetupOptions()
	Yikes:Update()
	afkFrame:Hide()
end

function Yikes:OnEnable()
	self:RegisterEvent("ZONE_CHANGED")
	self:RegisterEvent("CHAT_MSG_WHISPER")
	self:RegisterEvent("CHAT_MSG_PARTY")
	self:RegisterEvent("CHAT_MSG_RAID")
	self:RegisterEvent("CHAT_MSG_GUILD")
end

function Yikes:OnDisable()
	-- Called when the addon is disabled
end

function Yikes:Update()
	afkFrame:SetPoint("TOPLEFT",0,0)
	afkFrame:SetTimeVisible(5)
	afkFrame:SetFontObject("QuestFontNormalSmall")	
	afkFrame:SetJustifyH("Left")
	afkFrame:SetJustifyV("Bottom")
	afkFrame:EnableMouse(true)
	afkFrame:EnableMouseWheel(true)
	afkFrame:SetMaxLines(100)
	afkFrame:SetScript("OnMouseWheel", function(this, arg1)
		if arg1 > 0 then
			if IsShiftKeyDown() then
				this:ScrollToTop()
			else
				this:ScrollUp()
			end
		elseif arg1 < 0 then
			if IsShiftKeyDown() then
				this:ScrollToBottom()
			else
				this:ScrollDown()
			end
		end
	end)
	afkFrame:SetFrameStrata("TOOLTIP")
	afkFrame:SetWidth(UIParent:GetWidth())
	afkFrame:SetHeight(UIParent:GetHeight())
	--local mt = media:List('font')
	--afkFrame:SetFontObject(self.db.profile.font)
	afkFrame:SetFading(self.db.profile.fade)
	afkFrame:SetTimeVisible(self.db.profile.fadeDuration)
	texture:SetAllPoints(afkFrame)
	texture:SetTexture(self.db.profile.bgColour.r, self.db.profile.bgColour.g, self.db.profile.bgColour.b, self.db.profile.bgColour.a)
	afkFrame:SetTextColor(self.db.profile.textColour.r, self.db.profile.textColour.g, self.db.profile.textColour.b, self.db.profile.textColour.a)
end

function Yikes:ToggleScreen()
	if (screenVisible) then
		SendChatMessage(self.db.profile.afkMessage, "AFK")
		if (self.db.profile.alertPartyRaid) then 
			if (UnitInRaid("player")) then
				SendChatMessage(self.db.profile.afkMessage, "RAID")
			elseif (GetNumPartyMembers("player") > 0) then
				SendChatMessage(self.db.profile.afkMessage, "PARTY")
			end
		end
		if (self.db.profile.mute) then
			volume = GetCVar("Sound_MasterVolume")
			SetCVar("Sound_MasterVolume", 0)
		end
		self:Update()
		afkFrame:Show()
		screenVisible = false
	else
		SendChatMessage("", "AFK")
		if (self.db.profile.alertPartyRaid) then 
			if (UnitInRaid("player")) then
				SendChatMessage(self.db.profile.backMessage, "RAID")
			elseif (GetNumPartyMembers("player") > 0) then
				SendChatMessage(self.db.profile.backMessage, "PARTY")
			end
		end
		if (self.db.profile.mute) then
			SetCVar("Sound_MasterVolume", volume)
		end
		afkFrame:Hide()
		screenVisible = true
	end
end

function Yikes:ChatCommand(input)
	InterfaceOptionsFrame_OpenToFrame(self.optionsFrame)
end

function Yikes:ZONE_CHANGED()
	--afkFrame:PutMessage("[loc] "..GetZoneText().." "..GetSubZoneText())
end

function Yikes:CHAT_MSG_GUILD()
	if (Yikes.db.profile.channels["guild"]) then
		afkFrame:PutMessage("[g] ["..arg2.."] "..arg1)
	end
end

function Yikes:CHAT_MSG_PARTY()
	if (Yikes.db.profile.channels["party"]) then
		afkFrame:PutMessage("[p] ["..arg2.."] "..arg1)
	end
end

function Yikes:CHAT_MSG_RAID()
	if (Yikes.db.profile.channels["raid"]) then
		afkFrame:PutMessage("[r] ["..arg2.."] "..arg1)
	end
end

function Yikes:CHAT_MSG_WHISPER()
	if (Yikes.db.profile.channels["whisper"]) then
		afkFrame:PutMessage("[w] ["..arg2.."] "..arg1)
	end
end

function afkFrame:PutMessage(s)
	self:AddMessage(s, Yikes.db.profile.textColour.r, Yikes.db.profile.textColour.g, Yikes.db.profile.textColour.b, Yikes.db.profile.textColour.a)
end